﻿var TMan = new N6LTimerMan();  //タイマーマネージャー
var x3domRuntime;
var intvl = 50;
var time = 0.0;
var add = 0.005;

var IDs = new Array(
'MAIN_001', 'MAIN_002', 'MAIN_003', 'MAIN_004', 
'MAIN_005', 'MAIN_006', 'MAIN_007', 'MAIN_008', 
'MAIN_009', 'MAIN_010', 'MAIN_011', 'MAIN_012', 
'MAIN_013', 'MAIN_014', 'MAIN_015', 'MAIN_016', 
'MAIN_017', 'MAIN_018', 'MAIN_019', 'MAIN_020', 
'MAIN_021', 'MAIN_022', 'MAIN_023', 'MAIN_024', 
'MAIN_025', 'MAIN_026', 'MAIN_027', 'MAIN_028', 
'MAIN_029', 'MAIN_030', 'MAIN_031', 'MAIN_032' 
);
var act = 0;
var time2 = 0.0;
var add2 = 0.001;
var R = 400;
var Y = 7.5;
var Z = -500;
var U = new N6LMatrix([[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]);

//メインループウサギ
function GLoop2(id){
  var rt = document.getElementById('myX3DWorld').runtime;
  if(rt && 0 < rt.canvas.doc.downloadCount) {
    TMan.timer[id].setalerm(function() { GLoop2(id); }, intvl);  //メインループ再セット
    return false;
  }


  var elm = document.getElementById(IDs[act]);
  elm.setAttribute('render', false);
  act++;
  if(31 < act) act = 0;
  elm = document.getElementById(IDs[act]);
  elm.setAttribute('render', true);

  //ウサギ移動
  U = U.UnitMat();
  U.x[1].x[0] = 0;
  U.x[2].x[0] = Y;
  U.x[3].x[0] = 0;

  var ay = new N6LVector(4, true).UnitVec(2);
  U = U.RotAxis(ay, time2 * 2 * Math.PI)
  var pos = new N6LVector([1,R,0,0],true);
  pos = U.Mul(pos);
  pos.x[3] += Z;
  U = U.TranslatedMat(pos);
  pos = U.Pos();

  //apply x3dom
  var rot = U.Vector();
  var spos = pos.ToX3DOM(true);
  var srot = rot.ToX3DOM();
  var elm = document.getElementById('usaT');
  elm.setAttribute('translation', spos.toString());
  elm = document.getElementById('usaR');
  elm.setAttribute('rotation', srot.toString());

  moveobj(t, pyr); //視点処理

  //タイマーを進める
  time2 += add2;
  if(1 <= time2) time2 = 0;

  TMan.timer[id].setalerm(function() { GLoop2(id); }, intvl);  //メインループ再セット
}


//メインループ水面
function GLoop(id)
{
  x3domRuntime = document.getElementById('myX3DWorld').runtime;
  if(!x3domRuntime){
    TMan.timer[id].setalerm(function() { GLoop(id); }, intvl);  //メインループセット
    return false;
  }


  //タイマーを進める
  time += add;
  if(1 <= time) time = 0;

  changeShaderParamValue('time', time.toString());

  TMan.timer[id].setalerm(function() { GLoop(id); }, intvl);  //メインループセット
  return true;
}

function enter() 
{
  TMan.add();
  TMan.timer[1].setalerm(function() { GLoop(1); }, intvl);  //メインループセット
  TMan.add();
  TMan.timer[2].setalerm(function() { GLoop2(2); }, intvl);  //メインループセット
}

//オブジェクト位置情報
//位置4*4マトリクス(継続パラメータ)
var A = false;
var AU = false;

var t = new N6LVector([1, 0, 0, 0], true);
var pyr = new N6LVector([1, 0, 0, 0], true); 
var d = new N6LVector([1, 0, 20, 80], true); 
//以上のように初期化してから、下の関数を呼び続ける

//ローカルトランスレートt,(1, tx, ty, tz)(新規パラメータ) 
//ピッチヨーロール(1, θp, θy, θr)(新規パラメータ) 
function moveobj(wt, wpyr) {
  if(!A) {
    if(x3domRuntime) {
      var vm = x3domRuntime.viewMatrix().inverse(); //ワールド回転行列取得
      A = new N6LMatrix().FromX3DOM(vm);
    }
    else return;
  }

  var outmat = [];
  var outv = [];
  var WA = A.MoveMat(outmat, outv, d, wpyr, wt); //目的の関数

  //値を適用
  AU = new N6LMatrix(outmat[0]);
  A = new N6LMatrix(WA);
  t = new N6LVector([1, 0, 0, 0], true);
  pyr = new N6LVector([1, 0, 0, 0], true);

  //x3domに適用
  var Vec = A.Vector();
  var pos = A.Pos();
  var eye = pos.ToX3DOM(true);
  var ori = Vec.ToX3DOM();
  var elm = document.getElementById('viewp001');
  elm.setAttribute('position', eye.toString());
  elm.setAttribute('orientation', ori.toString());

  Vec = AU.Vector();
  pos = AU.Pos();
  eye = pos.ToX3DOM(true);
  ori = Vec.ToX3DOM();
  elm = document.getElementById('usaT_1');
  elm.setAttribute('translation', eye.toString());
  elm = document.getElementById('usaR_1');
  elm.setAttribute('rotation', ori.toString());
}

var lock = false;

//キー入力
function chkKeyBoard(){
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N1'))]) {//N1Key
    t.x[1] -= 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N2'))]) {//N2Key
    t.x[3] += 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N3'))]) {//N3Key
    t.x[1] += 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N4'))]) {//N4Key
    pyr.x[2] -= 2.5 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N5'))]) {//N5Key
    if(!lock) pyr.x[2] += 180 * (Math.PI / 180);
    lock = true;
  }
  else lock = false;
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N6'))]) {//N6Key
    pyr.x[2] += 2.5 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N8'))]) {//N8Key
    t.x[3] -= 5;
  }
};

function chkKeyBoard2(){
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N1'))]) {//N1Key
    pyr.x[3] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N2'))]) {//N2Key
    pyr.x[1] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N3'))]) {//N3Key
    pyr.x[3] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N4'))]) {//N4Key
    pyr.x[2] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N5'))]) {//N5Key
    t = new N6LVector([1, 0, 0, 0], true);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N6'))]) {//N6Key
    pyr.x[2] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N7'))]||KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_C'))]) {//N7Key,ckey
    t.x[3] += 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N8'))]) {//N8Key
    pyr.x[1] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N9'))]||KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_F'))]) {//N9Key,fkey
    t.x[3] -= 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_A'))]) {//aKey
    t.x[1] -= 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_W'))]) {//wKey
    t.x[2] += 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_D'))]) {//dKey
    t.x[1] += 5;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_X'))]) {//xKey
    t.x[2] -= 5;
  }
};

